
export interface SymptomDatensatz { 
    name: string;  
    picture: string; 
    introduction: Array<string> | Array<React.ReactNode>;
}

//Bilder+Quellen müssen noch angepasst werden
//da kommen jetzt folgende Organe: Pancreas, Intestines, Liver, Sexual glands, Lungs, Skeletal System, Skin, Nose, Brain/Mental Health 
export const symptomdata: (Array<SymptomDatensatz>)  = [
    {
        name: "Pancreas",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/pancreas.svg",
        introduction: [<>Located behind the stomach in the back abdominal cavity [1]</>,<>Responsible for neutralizing stomach acid, production of hormones (like Insulin) and digestion enzymes [1]</>,<>Clogging caused by CF, so that products of the pancreatic gland can not be distributed [2]</>,<>Pancreatic insufficiency due to CF can lead to malnutrition [3], digestive problems and abdominal pain [4], CF-associated diabetes [5]</>,<>Treatment options include nutritional therapy and supplementation of pancreatic enzymes [6]</>]
    },
    { 
        name: "Intestines", 
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/largeintestine.svg",
        introduction: [<>Located in the abdominal cavity and extends from the stomach to the anus</>,<>Responsible for nutrient absorption, water reabsorption, and waste elimination [7]</>,<>CF can cause blocking of the intestines, preventing the normal movement of food and absorption of nutrients [8]</>,<>Intestinal blockage due to CF can lead to malabsorption of nutrients, and conditions like meconium ileus in newborns or distal intestinal obstruction syndrome (DIOS) in adults [8]</>,<>Treatment options include the use of laxatives, enzyme supplementation, feeding tubes, and in severe cases, surgical intervention or intestinal transplantation [8]</>]
    },
    {
        name: "Liver", 
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/liver.svg",
        introduction: [<>Located directly below the diaphragm near the pancreatic gland and stomach [9]</>,<>Responsible for detoxification, bile production for enhancement of digestion, protein synthesis for blood clotting and immune functions, nutrient processing and storage [9]</>,<>CF affects the normal secretion and function of bile- it becomes stickier [10]</>,<>Symptoms caused by CF include bruising, nose bleeds, Inflammation, more frequent chest infections, low body weight, liver cirrhosis, lethargy [10]</>,<>Treatment options include nutritional therapy, modulators, UDCA, liver transplantation [11]</>]
    },
    {
        name: "Sexual glands",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/glands.svg",
        introduction: [<>Located in pelvic area [12]</>,<>Responsible for production of sperm (male)/ production of oocytes and as site for embryo development (female) [13]</>,<>CF causes thick mucus to block reproductive ducts (both), affects sperm transport (male) [14] and cervical mucus density (female) [15]</>,<>This can lead in context of CF to reduced fertility or even infertility [14][15]</>,<> <i> In vitro </i> fertilization can be an option for CF patients [16] </>]
    },
    {
        name: "Lungs", 
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/lungs.svg",
        introduction: [<>Located in the ribcage [17]</>,<>Responsible for breathing – aspiration of life-giving oxygen and deposition of carbondioxide [17]</>,<>CF causes the thickening of mucus on top of the respiratory epithelium, serving as nutrition ground as for pathogens and impairing the movement of cilia so that the mucus can not be cart away [18]</>,<>Symptoms caused by CF include shortness of breath, persistent cough [19], lung infections (mainly caused by <i> Pseudomonas aeruginosa </i>, <i> Staphylococcus aureus </i> and <i> Burkholderia cepacia </i>) [20], bronchiectasis [21] </>,<>Treatment options include respiratory physiotherapy (e.g. bronchiodilators), sports, inhalation, antibiotics against pathogens, lung transplantation [22]</>]
    },
    {
        name: "Skeletal System",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/bones.svg",
        introduction: [<>Located throughout the entire body</>,<>Responsible for structuration of the body, protection of organs, mineral storage, blood cell production [23]</>,<>CF affects the skeletal system by reducing bone mineral density [24]</>,<>This can lead in context of CF to osteoporosis, spinal fractures, kyphosis, scoliosis [24]</>,<>Treatment options include uptake of biophosphonates to increase bone density, vitamin D for maintenance of calcium levels needed for mineralization [24]</>]
    },
    {
        name: "Skin",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/skin.svg",
        introduction: [<>Located on the surface of the entire body</>,<>Responsible for barrier function, immunological defense, regulation of homeostasis, sensory functions [25]</>,<>CF affects CFTR channels of sweat glands, which leads to salt deposits on the skin [26]</>,<>This can lead in context of CF to skin irritation (rash or dermatitis) [26]</>,<>Prevention via drinking a lot and a rather salty diet possible [27]</>]
    },
    {
        name: "Nose",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/nose.svg",
        introduction: [<></>,<>Responsible for smell perception, breathing, filtration and cleaning, and serving as a resonance chamber for the voice [28]</>,<>CF affects thickness of nasal secretions, which cannot drain well [26]</>,<>This can lead in context of CF to nasal congestion, pressure headaches, sinusitis, inflammation of nasal polyps [26]</>,<>Therapy ranges from nasal sprays to surgical removal of nasal polyps [26]</>]
    },
    {
        name: "Brain",
        picture: "https://static.igem.wiki/teams/5247/scientific-figures/brain.svg",
        introduction: [<>Located inside the skull</>,<>Responsible for cognitive functions, movement coordination, and control of vital functions [29]</>,<>CF affects mental health due to psychological stress and social isolation [30]</>,<>This can lead in context of CF to physical illnesses like depression and anxiety disorders [30]</>,<>Treatment options include psychotherapy, antidepressants, support groups and sports [31]</>]
    }
]